global xx yy

dane = load('dane_1.txt');
[w k] = size(dane);
xx = dane(:,1:end-1);
yy = dane(:,end);

if k == 2
    figure(1)
    plot(xx,yy,'o');
    hold on
elseif k == 3
    figure(1)
    plot3(xx(:,1), xx(:,2), yy,'o');
    hold on
end

pause

format compact

% Setting the seed to the same for binary
% rand('seed',156789)

global bounds

% Bounds on the variables
bounds = [-10 10; -10 10; -10 10; -10 10];

% Generate an intialize population of size 20
startPop = initializega(20,bounds,'Approxy',[],[1e-6 1]);

% Binary Crossover Operators
% xFns = 'simpleXover';
% xOpts = [0.8];

% Crossover Operators
xFns = 'arithXover heuristicXover simpleXover';
xOpts = [1 0; 3 3; 5 0];

% Binary Mutation Operators
% mFns = 'binaryMutation';
% mOpts = [0.05];

% Mutation Operators
mFns = 'boundaryMutation multiNonUnifMutation nonUnifMutation unifMutation';
mOpts = [2 0 0;3 200 3;10 200 3;5 0 0];

% Termination Operators
termFns = 'maxGenTerm';
termOps = [200]; % 200 Generations

% Selection Function 
% selectFn = 'roulette';
% selectOps = [];

selectFn = 'tournSelect';
selectOps = [2];

% Selection Function
%selectFn = 'normGeomSelect';
%selectOps = [0.08];

% Evaluation Function
evalFn = 'Approxy';
evalOps = [];

% GA Options [epsilon float/binar display]
gaOpts=[1e-6 1 1];

% Lets run the GA
[x endPop bestPop trace]=ga(bounds,evalFn,evalOps,startPop,gaOpts,...
    termFns,termOps,selectFn,selectOps,xFns,xOpts,mFns,mOpts);


% x is the best solution found
x_best_sol = x;

%f = x(1)*(xx.^3) + x(2)*(xx.^2) + x(3)*xx + x(4);
f = x(1)*sin(x(2)*xx) + x(3)*cos(x(4)*xx);
if k == 2
    plot(xx,f);
    hold off
end

disp('Best solution') 
x
disp('Hit a return to continue')
pause


% endPop is the ending population
disp('Ending population')
endPop
disp('Hit a return to continue')
pause


% bestPop is the best solution tracked over generations
disp('Best solution tracked over generations')
bestPop
disp('Hit a return to continue')
pause


% trace is a trace of the best value and average value of generations
% trace
% Hit a return to continue
% pause


% Plot the best over time
figure(2)
clf
plot(trace(:,1),trace(:,2));
% Add the average to the graph
hold on
plot(trace(:,1),trace(:,3));
hold off
